Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 3211)
@@ -49,4 +49,11 @@
    PUBLIC    dyn_nxt   ! routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -95,4 +102,7 @@
       USE oce     , ONLY:   ze3u_f => ta       , ze3v_f => sa       ! (ta,sa) used as 3D workspace
       USE wrk_nemo, ONLY:   zs_t   => wrk_2d_1 , zs_u_1 => wrk_2d_2 , zs_v_1 => wrk_2d_3
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ze3u_f :I :I :z
+!FTRANS ze3v_f :I :I :z
       !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
@@ -214,15 +224,32 @@
       ! ------------------------------------------
       IF( neuler == 0 .AND. kt == nit000 ) THEN        !* Euler at first time-step: only swap
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  un(ji,jj,jk) = ua(ji,jj,jk)                ! un <-- ua
+                  vn(ji,jj,jk) = va(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             un(:,:,jk) = ua(:,:,jk)                          ! un <-- ua
             vn(:,:,jk) = va(:,:,jk)
          END DO
+#endif
       ELSE                                             !* Leap-Frog : Asselin filter and swap
          !                                ! =============!
          IF( .NOT. lk_vvl ) THEN          ! Fixed volume !
             !                             ! =============!
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO ji = 1, jpi    
+                  DO jk = 1, jpkm1                              
+#else
             DO jk = 1, jpkm1                              
                DO jj = 1, jpj
                   DO ji = 1, jpi    
+#endif
                      zuf = un(ji,jj,jk) + atfp * ( ub(ji,jj,jk) - 2.e0 * un(ji,jj,jk) + ua(ji,jj,jk) )
                      zvf = vn(ji,jj,jk) + atfp * ( vb(ji,jj,jk) - 2.e0 * vn(ji,jj,jk) + va(ji,jj,jk) )
@@ -247,5 +274,9 @@
             ! Add volume filter correction only at the first level of t-point scale factors
             zec = atfp * rdt / rau0
+#if defined key_z_first
+            fse3t_b(:,:,1) = fse3t_b(:,:,1) - zec * ( emp_b(:,:) - emp(:,:) ) * tmask_1(:,:)
+#else
             fse3t_b(:,:,1) = fse3t_b(:,:,1) - zec * ( emp_b(:,:) - emp(:,:) ) * tmask(:,:,1)
+#endif
             ! surface at t-points and inverse surface at (u/v)-points used in surface averaging computations
             zs_t  (:,:) =       e1t(:,:) * e2t(:,:)
@@ -257,7 +288,13 @@
                ! -----------------------------------
                ! Scale factor anomaly at (u/v)-points: surface averaging of scale factor at t-points
+#if defined key_z_first
+               DO jj = 1, jpjm1
+                  DO ji = 1, jpim1
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpjm1
                      DO ji = 1, jpim1
+#endif
                         zv_t_ij           = zs_t(ji  ,jj  ) * fse3t_b(ji  ,jj  ,jk)
                         zv_t_ip1j         = zs_t(ji+1,jj  ) * fse3t_b(ji+1,jj  ,jk)
@@ -276,7 +313,13 @@
                ! Leap-Frog - Asselin filter and swap: applied on velocity
                ! -----------------------------------
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
                      DO ji = 1, jpi
+#endif
                         zuf = un(ji,jj,jk) + atfp * ( ub(ji,jj,jk) - 2.e0 * un(ji,jj,jk) + ua(ji,jj,jk) )
                         zvf = vn(ji,jj,jk) + atfp * ( vb(ji,jj,jk) - 2.e0 * vn(ji,jj,jk) + va(ji,jj,jk) )
@@ -294,7 +337,13 @@
                !-----------------------------------------------
                ! Scale factor anomaly at (u/v)-points: surface averaging of scale factor at t-points
+#if defined key_z_first
+               DO jj = 1, jpjm1
+                  DO ji = 1, jpim1
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpjm1
                      DO ji = 1, jpim1
+#endif
                         zv_t_ij          = zs_t(ji  ,jj  ) * fse3t_b(ji  ,jj  ,jk)
                         zv_t_ip1j        = zs_t(ji+1,jj  ) * fse3t_b(ji+1,jj  ,jk)
@@ -313,7 +362,13 @@
                ! Leap-Frog - Asselin filter and swap: applied on thickness weighted velocity
                ! -----------------------------------             ===========================
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji = 1, jpim1
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
                      DO ji = 1, jpim1
+#endif
                         zue3a = ua(ji,jj,jk) * fse3u_a(ji,jj,jk)
                         zve3a = va(ji,jj,jk) * fse3v_a(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 3211)
@@ -38,4 +38,10 @@
    INTEGER ::   nspg = 0   ! type of surface pressure gradient scheme defined from lk_dynspg_... 
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -76,4 +82,8 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztrdu => wrk_3d_4 , ztrdv => wrk_3d_5    ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
+
       !
       INTEGER, INTENT(in   ) ::   kt       ! ocean time-step index
@@ -108,7 +118,13 @@
             END DO
          END DO
+#if defined key_z_first
+         DO jj = 2, jpjm1                          ! Add the apg to the general trend
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                          ! Add the apg to the general trend
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) + spgu(ji,jj)
                   va(ji,jj,jk) = va(ji,jj,jk) + spgv(ji,jj)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90	(revision 3211)
@@ -33,4 +33,10 @@
 
    PUBLIC   dyn_spg_exp   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -89,7 +95,13 @@
             END DO 
          END DO 
+#if defined key_z_first
+         DO jj = 2, jpjm1                    ! Add it to the general trend
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                    ! Add it to the general trend
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) + spgu(ji,jj)
                   va(ji,jj,jk) = va(ji,jj,jk) + spgv(ji,jj)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 3211)
@@ -56,4 +56,12 @@
    PUBLIC   flt_rst      ! routine called by istate.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -104,4 +112,7 @@
       !!---------------------------------------------------------------------
       USE oce, ONLY:   zub   => ta , zvb   => sa   ! (ta,sa) used as workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zub :I :I :z
+!FTRANS zvb :I :I :z
       !!
       INTEGER, INTENT(in   ) ::   kt       ! ocean time-step index
@@ -138,7 +149,13 @@
          !
          IF( ln_dynadv_vec ) THEN      ! vector form : applied on velocity
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      ua(ji,jj,jk) = (  ub(ji,jj,jk) + z2dt * ua(ji,jj,jk)  ) * umask(ji,jj,jk)
                      va(ji,jj,jk) = (  vb(ji,jj,jk) + z2dt * va(ji,jj,jk)  ) * vmask(ji,jj,jk)
@@ -148,7 +165,13 @@
             !
          ELSE                          ! flux form : applied on thickness weighted velocity
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      ua(ji,jj,jk) = (        ub(ji,jj,jk) * fse3u_b(ji,jj,jk)      &
                         &           + z2dt * ua(ji,jj,jk) * fse3u_n(ji,jj,jk)  )   &
@@ -171,7 +194,13 @@
             END DO 
          END DO 
+#if defined key_z_first
+         DO jj = 2, jpjm1              ! unweighted time stepping 
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1              ! unweighted time stepping 
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ua(ji,jj,jk) = (  ub(ji,jj,jk) + z2dt * ( ua(ji,jj,jk) + spgu(ji,jj) )  ) * umask(ji,jj,jk)
                   va(ji,jj,jk) = (  vb(ji,jj,jk) + z2dt * ( va(ji,jj,jk) + spgv(ji,jj) )  ) * vmask(ji,jj,jk)
@@ -214,7 +243,13 @@
          END DO
       ELSE                        ! No  vector opt.
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = 2, jpim1
+#endif
                   spgu(ji,jj) = spgu(ji,jj) + fse3u(ji,jj,jk) * ua(ji,jj,jk)
                   spgv(ji,jj) = spgv(ji,jj) + fse3v(ji,jj,jk) * va(ji,jj,jk)
@@ -333,7 +368,13 @@
       !                       trend, the leap-frog time stepping will not
       !                       be done in dynnxt.F90 routine)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ua(ji,jj,jk) = ( ua(ji,jj,jk) + spgu(ji,jj) ) * umask(ji,jj,jk)
                va(ji,jj,jk) = ( va(ji,jj,jk) + spgv(ji,jj) ) * vmask(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 3211)
@@ -57,4 +57,12 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ub_b, vb_b   ! before averaged velocity
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -179,4 +187,9 @@
       zva(:,:) = 0.e0   ;   zvn(:,:) = 0.e0   ;   vb_b(:,:) = 0.e0
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
 #if defined key_vectopt_loop
@@ -186,4 +199,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
 #endif
                !                                                                              ! now trend
@@ -206,7 +220,13 @@
 
       !                                   !* baroclinic momentum trend (remove the vertical mean trend)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1                    ! --------------------------
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ua(ji,jj,jk) = ua(ji,jj,jk) - zua(ji,jj) * hur(ji,jj)
                va(ji,jj,jk) = va(ji,jj,jk) - zva(ji,jj) * hvr(ji,jj)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 3211)
@@ -52,4 +52,8 @@
    INTEGER ::   ntot = 4   ! =4 total vorticity (relative + planetary) ; =5 coriolis + metric term
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -72,4 +76,8 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   ztrdu => ta , ztrdv => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
+
       !
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -210,6 +218,11 @@
       INTEGER , INTENT(in   )                         ::   kvor   ! =ncor (planetary) ; =ntot (total) ;
       !                                                           ! =nrvm (relative vorticity or metric)
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+!FTRANS pua :I :I :z
+!FTRANS pva :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+      REAL(wp), INTENT(inout) ::   pua(jpi,jpj,jpk)    ! total u-trend
+      REAL(wp), INTENT(inout) ::   pva(jpi,jpj,jpk)    ! total v-trend
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -441,6 +454,11 @@
       INTEGER , INTENT(in   )                         ::   kvor   ! =ncor (planetary) ; =ntot (total) ;
          !                                                        ! =nrvm (relative vorticity or metric)
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+!FTRANS pua :I :I :z
+!FTRANS pva :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+      REAL(wp), INTENT(inout) ::   pua(jpi,jpj,jpk)    ! total u-trend
+      REAL(wp), INTENT(inout) ::   pva(jpi,jpj,jpk)    ! total v-trend
       !
       INTEGER  ::   ji, jj, jk           ! dummy loop indices
@@ -552,4 +570,5 @@
       USE wrk_nemo, ONLY:   ztsw => wrk_2d_6 , ztse => wrk_2d_7
 #if defined key_vvl
+!FTRANS ze3f :I :I :z
       USE wrk_nemo, ONLY:   ze3f => wrk_3d_1                                           ! 3D workspace (lk_vvl=T)
 #endif
@@ -558,6 +577,11 @@
       INTEGER , INTENT(in   )                         ::   kvor   ! =ncor (planetary) ; =ntot (total) ;
       !                                                           ! =nrvm (relative vorticity or metric)
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+!FTRANS pua :I :I :z
+!FTRANS pva :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua    ! total u-trend
+!     REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva    ! total v-trend
+      REAL(wp), INTENT(inout) ::   pua(jpi,jpj,jpk)    ! total u-trend
+      REAL(wp), INTENT(inout) ::   pva(jpi,jpj,jpk)   ! total v-trend
       !!
       INTEGER  ::   ji, jj, jk         ! dummy loop indices
@@ -565,4 +589,5 @@
       REAL(wp) ::   zfac12, zua, zva   ! local scalars
 #if ! defined key_vvl
+!FTRANS ze3f :I :I :z
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), SAVE ::   ze3f     ! lk_vvl=F, ze3f=1/e3f saved one for all
 #endif
@@ -599,5 +624,4 @@
       zfac12 = 1._wp / 12._wp    ! Local constant initialization
 
-      
 !CDIR PARALLEL DO PRIVATE( zwx, zwy, zwz, ztnw, ztne, ztsw, ztse )
       !                                                ! ===============
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 3211)
@@ -26,4 +26,9 @@
    
    PUBLIC   dyn_zad   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -57,4 +62,9 @@
       USE oce     , ONLY:   zwuw  => ta       , zwvw  => sa          ! (ta,sa) used as 3D workspace
       USE wrk_nemo, ONLY:   ztrdu => wrk_3d_1 , ztrdv => wrk_3d_2    ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwuw  :I :I :z
+!FTRANS zwvw  :I :I :z
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step inedx
@@ -77,5 +87,27 @@
          ztrdv(:,:,:) = va(:,:,:) 
       ENDIF
-      
+
+#if defined key_z_first
+      !! DCSE_NEMO: Attention! Eliminate k-dependence from zww to re-order loops
+      DO jj = 2, jpj                   ! vertical fluxes 
+         DO ji = 2, jpi
+            zww(ji,jj) = 0.25 * e1t(ji,jj) * e2t(ji,jj)
+         END DO
+      END DO
+      DO jj = 2, jpjm1                 ! vertical momentum advection at w-point
+         DO ji = 2, jpim1
+            zwuw(ji,jj, 1 ) = 0.e0     ! Surface values set to zero
+            zwvw(ji,jj, 1 ) = 0.e0
+            DO jk = 2, jpkm1
+               zwuw(ji,jj,jk) =   ( zww(ji+1,jj  )*wn(ji+1,jj  ,jk) + zww(ji,jj)*wn(ji,jj,jk) )   &
+                  &             * ( un(ji,jj,jk-1)-un(ji,jj,jk) ) 
+               zwvw(ji,jj,jk) =   ( zww(ji  ,jj+1)*wn(ji  ,jj+1,jk) + zww(ji,jj)*wn(ji,jj,jk) )   &
+                  &             * ( vn(ji,jj,jk-1)-vn(ji,jj,jk) )
+            END DO  
+            zwuw(ji,jj,jpk) = 0.e0     ! Bottom values set to zero
+            zwvw(ji,jj,jpk) = 0.e0
+         END DO   
+      END DO
+#else
       DO jk = 2, jpkm1              ! Vertical momentum advection at level w and u- and v- vertical
          DO jj = 2, jpj                   ! vertical fluxes 
@@ -99,8 +131,15 @@
          END DO  
       END DO
+#endif
 
+#if defined key_z_first
+      DO jj = 2, jpjm1              ! Vertical momentum advection at u- and v-points
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1              ! Vertical momentum advection at u- and v-points
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1       ! vector opt.
+#endif
                !                         ! vertical momentum advective trends
                zua = - ( zwuw(ji,jj,jk) + zwuw(ji,jj,jk+1) ) / ( e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk) )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 3211)
@@ -35,4 +35,10 @@
    REAL(wp) ::   r2dt       ! time-step, = 2 rdttra except at nit000 (=rdttra) if neuler=0
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -55,4 +61,7 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztrdu => wrk_3d_1 , ztrdv => wrk_3d_2    ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
       !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
@@ -112,4 +121,5 @@
       USE zdfgls
       USE zdfkpp
+#  include "zdftke_ftrans.h90"
       !!----------------------------------------------------------------------
       !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 3211)
@@ -27,4 +27,10 @@
 
    PUBLIC   dyn_zdf_exp   ! called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
    
    !! * Substitutions
@@ -57,4 +63,9 @@
       USE oce     , ONLY:   zwx => ta       , zwy => sa         ! (ta,sa) used as 3D workspace
       USE wrk_nemo, ONLY:   zwz => wrk_3d_1 , zww => wrk_3d_2   ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx :I :I :z
+!FTRANS zwy :I :I :z
+!FTRANS zwz :I :I :z
+!FTRANS zww :I :I :z
       !
       INTEGER , INTENT(in) ::   kt     ! ocean time-step index
@@ -85,7 +96,13 @@
          END DO  
       END DO  
+#if defined key_z_first
+      DO jj = 2, jpjm1                 ! Initialization of x, z and contingently trends array
+         DO ji = 2, jpim1
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk                   ! Initialization of x, z and contingently trends array
          DO jj = 2, jpjm1 
             DO ji = 2, jpim1
+#endif
                zwx(ji,jj,jk) = ub(ji,jj,jk)
                zwz(ji,jj,jk) = vb(ji,jj,jk)
@@ -96,7 +113,13 @@
       DO jl = 1, nn_zdfexp             ! Time splitting loop
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 2, jpk                ! First vertical derivative
+#else
          DO jk = 2, jpk                      ! First vertical derivative
             DO jj = 2, jpjm1 
                DO ji = 2, jpim1
+#endif
                   zwy(ji,jj,jk) = avmu(ji,jj,jk) * ( zwx(ji,jj,jk-1) - zwx(ji,jj,jk) ) / fse3uw(ji,jj,jk) 
                   zww(ji,jj,jk) = avmv(ji,jj,jk) * ( zwz(ji,jj,jk-1) - zwz(ji,jj,jk) ) / fse3vw(ji,jj,jk)
@@ -104,7 +127,13 @@
             END DO  
          END DO  
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1              ! Second vertical derivative and trend estimation at kt+l*rdt/nn_zdfexp
+#else
          DO jk = 1, jpkm1                    ! Second vertical derivative and trend estimation at kt+l*rdt/nn_zdfexp
             DO jj = 2, jpjm1 
                DO ji = 2, jpim1
+#endif
                   zua = zlavmr * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) ) / fse3u(ji,jj,jk)
                   zva = zlavmr * ( zww(ji,jj,jk) - zww(ji,jj,jk+1) ) / fse3v(ji,jj,jk)
